LogFactory (Commons Logging 1.1.1 API)
Keywords: org.apache.commons.logging.LogFactory class

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.commons.logging
Class LogFactory

    java.lang.Object
      org.apache.commons.logging.LogFactory

Direct Known Subclasses:
  LogFactoryImpl

public abstract class LogFactory
extends java.lang.Object

Factory for creating `Log` instances, with discovery and configuration features similar to that employed by standard Java APIs such as JAXP.

IMPLEMENTATION NOTE - This implementation is heavily based on the SAXParserFactory and DocumentBuilderFactory implementations (corresponding to the JAXP pluggability APIs) found in Apache Xerces.

Version:
  $Revision: 593798 $ $Date: 2007-11-10 18:40:43 +0100 $
Author:
  Craig R. McClanahan, Costin Manolache, Richard A. Sitze

Field Summary
`static java.lang.String` | `DIAGNOSTICS_DEST_PROPERTY` The name (`org.apache.commons.logging.diagnostics.dest`) of the property used to enable internal commons-logging diagnostic output, in order to get information on what logging implementations are being discovered, what classloaders they are loaded through, etc.
`protected static java.util.Hashtable` | `factories` The previously constructed `LogFactory` instances, keyed by the `ClassLoader` with which it was created.
`static java.lang.String` | `FACTORY_DEFAULT` The fully qualified class name of the fallback `LogFactory` implementation class to use, if no other can be found.
`static java.lang.String` | `FACTORY_PROPERTIES` The name (`commons-logging.properties`) of the properties file to search for.
`static java.lang.String` | `FACTORY_PROPERTY` The name (`org.apache.commons.logging.LogFactory`) of the property used to identify the LogFactory implementation class name.
`static java.lang.String` | `HASHTABLE_IMPLEMENTATION_PROPERTY` Setting this system property (`org.apache.commons.logging.LogFactory.HashtableImpl`) value allows the `Hashtable` used to store classloaders to be substituted by an alternative implementation.
`protected static LogFactory` | `nullClassLoaderFactory` Prevously constructed `LogFactory` instance as in the `factories` map, but for the case where `getClassLoader` returns `null`.
`static java.lang.String` | `PRIORITY_KEY` The name (`priority`) of the key in the config file used to specify the priority of that particular config file.
`protected static java.lang.String` | `SERVICE_ID` JDK1.3+ 'Service Provider' specification.
`static java.lang.String` | `TCCL_KEY` The name (`use_tccl`) of the key in the config file used to specify whether logging classes should be loaded via the thread context class loader (TCCL), or not.

Constructor Summary
`protected` | `LogFactory()` Protected constructor that is not available for public use.

Method Summary
`protected static java.lang.Object` | `createFactory(java.lang.String factoryClass, java.lang.ClassLoader classLoader)` Implements the operations described in the javadoc for newFactory.
`protected static java.lang.ClassLoader` | `directGetContextClassLoader()` Return the thread context class loader if available; otherwise return null.
`abstract java.lang.Object` | `getAttribute(java.lang.String name)` Return the configuration attribute with the specified name (if any), or `null` if there is no such attribute.
`abstract java.lang.String[]` | `getAttributeNames()` Return an array containing the names of all currently defined configuration attributes.
`protected static java.lang.ClassLoader` | `getClassLoader(java.lang.Class clazz)` Safely get access to the classloader for the specified class.
`protected static java.lang.ClassLoader` | `getContextClassLoader()` Returns the current context classloader.
`static LogFactory` | `getFactory()` Construct (if necessary) and return a `LogFactory` instance, using the following ordered lookup procedure to determine the name of the implementation class to be loaded.
`abstract Log` | `getInstance(java.lang.Class clazz)` Convenience method to derive a name from the specified class and call `getInstance(String)` with it.
`abstract Log` | `getInstance(java.lang.String name)` Construct (if necessary) and return a `Log` instance, using the factory's current set of configuration attributes.
`static Log` | `getLog(java.lang.Class clazz)` Convenience method to return a named logger, without the application having to care about factories.
`static Log` | `getLog(java.lang.String name)` Convenience method to return a named logger, without the application having to care about factories.
`protected static boolean` | `isDiagnosticsEnabled()` Indicates true if the user has enabled internal logging.
`protected static void` | `logRawDiagnostic(java.lang.String msg)` Write the specified message to the internal logging destination.
`protected static LogFactory` | `newFactory(java.lang.String factoryClass, java.lang.ClassLoader classLoader)` Method provided for backwards compatibility; see newFactory version that takes 3 parameters.
`protected static LogFactory` | `newFactory(java.lang.String factoryClass, java.lang.ClassLoader classLoader, java.lang.ClassLoader contextClassLoader)` Return a new instance of the specified `LogFactory` implementation class, loaded by the specified class loader.
`static java.lang.String` | `objectId(java.lang.Object o)` Returns a string that uniquely identifies the specified object, including its class.
`abstract void` | `release()` Release any internal references to previously created `Log` instances returned by this factory.
`static void` | `release(java.lang.ClassLoader classLoader)` Release any internal references to previously created `LogFactory` instances that have been associated with the specified class loader (if any), after calling the instance method `release()` on each of them.
`static void` | `releaseAll()` Release any internal references to previously created `LogFactory` instances, after calling the instance method `release()` on each of them.
`abstract void` | `removeAttribute(java.lang.String name)` Remove any configuration attribute associated with the specified name.
`abstract void` | `setAttribute(java.lang.String name, java.lang.Object value)` Set the configuration attribute with the specified name.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### PRIORITY_KEY

    public static final java.lang.String PRIORITY_KEY

  The name (`priority`) of the key in the config file used to specify the priority of that particular config file. The associated value is a floating-point number; higher values take priority over lower values.

  See Also:
    Constant Field Values

### TCCL_KEY

    public static final java.lang.String TCCL_KEY

  The name (`use_tccl`) of the key in the config file used to specify whether logging classes should be loaded via the thread context class loader (TCCL), or not. By default, the TCCL is used.

  See Also:
    Constant Field Values

### FACTORY_PROPERTY

    public static final java.lang.String FACTORY_PROPERTY

  The name (`org.apache.commons.logging.LogFactory`) of the property used to identify the LogFactory implementation class name. This can be used as a system property, or as an entry in a configuration properties file.

  See Also:
    Constant Field Values

### FACTORY_DEFAULT

    public static final java.lang.String FACTORY_DEFAULT

  The fully qualified class name of the fallback `LogFactory` implementation class to use, if no other can be found.

  See Also:
    Constant Field Values

### FACTORY_PROPERTIES

    public static final java.lang.String FACTORY_PROPERTIES

  The name (`commons-logging.properties`) of the properties file to search for.

  See Also:
    Constant Field Values

### SERVICE_ID

    protected static final java.lang.String SERVICE_ID

  JDK1.3+ 'Service Provider' specification.

  See Also:
    Constant Field Values

### DIAGNOSTICS_DEST_PROPERTY

    public static final java.lang.String DIAGNOSTICS_DEST_PROPERTY

  The name (`org.apache.commons.logging.diagnostics.dest`) of the property used to enable internal commons-logging diagnostic output, in order to get information on what logging implementations are being discovered, what classloaders they are loaded through, etc.

  If a system property of this name is set then the value is assumed to be the name of a file. The special strings STDOUT or STDERR (case-sensitive) indicate output to System.out and System.err respectively.

  Diagnostic logging should be used only to debug problematic configurations and should not be set in normal production use.

  See Also:
    Constant Field Values

### HASHTABLE_IMPLEMENTATION_PROPERTY

    public static final java.lang.String HASHTABLE_IMPLEMENTATION_PROPERTY

  Setting this system property (`org.apache.commons.logging.LogFactory.HashtableImpl`) value allows the `Hashtable` used to store classloaders to be substituted by an alternative implementation.

  Note: `LogFactory` will print: ``

       [ERROR] LogFactory: Load of custom hashtable failed

  to system error and then continue using a standard Hashtable.

  Usage: Set this property when Java is invoked and `LogFactory` will attempt to load a new instance of the given implementation class. For example, running the following ant scriplet: ``

        <java classname="${test.runner}" fork="yes" failonerror="${test.failonerror}">
           ...
           <sysproperty
              key="org.apache.commons.logging.LogFactory.HashtableImpl"
              value="org.apache.commons.logging.AltHashtable"/>
        </java>

  will mean that `LogFactory` will load an instance of `org.apache.commons.logging.AltHashtable`.

  A typical use case is to allow a custom Hashtable implementation using weak references to be substituted. This will allow classloaders to be garbage collected without the need to release them (on 1.3+ JVMs only, of course ;)

  See Also:
    Constant Field Values

### factories

    protected static java.util.Hashtable factories

  The previously constructed `LogFactory` instances, keyed by the `ClassLoader` with which it was created.

### nullClassLoaderFactory

    protected static LogFactory nullClassLoaderFactory

  Prevously constructed `LogFactory` instance as in the `factories` map, but for the case where `getClassLoader` returns `null`. This can happen when:
  - using JDK1.1 and the calling code is loaded via the system classloader (very common)
  - using JDK1.2+ and the calling code is loaded via the boot classloader (only likely for embedded systems work).
  Note that `factories` is a Hashtable (not a HashMap), and hashtables don't allow null as a key.

Constructor Detail

### LogFactory

    protected LogFactory()

  Protected constructor that is not available for public use.

Method Detail

### getAttribute

    public abstract java.lang.Object getAttribute(java.lang.String name)

  Return the configuration attribute with the specified name (if any), or `null` if there is no such attribute.

  Parameters:
    `name` - Name of the attribute to return

### getAttributeNames

    public abstract java.lang.String[] getAttributeNames()

  Return an array containing the names of all currently defined configuration attributes. If there are no such attributes, a zero length array is returned.

### getInstance

    public abstract Log getInstance(java.lang.Class clazz)
                             throws LogConfigurationException

  Convenience method to derive a name from the specified class and call `getInstance(String)` with it.

  Parameters:
    `clazz` - Class for which a suitable Log name will be derived
  Throws:
    `LogConfigurationException` - if a suitable `Log` instance cannot be returned

### getInstance

    public abstract Log getInstance(java.lang.String name)
                             throws LogConfigurationException

  Construct (if necessary) and return a `Log` instance, using the factory's current set of configuration attributes.

  NOTE - Depending upon the implementation of the `LogFactory` you are using, the `Log` instance you are returned may or may not be local to the current application, and may or may not be returned again on a subsequent call with the same name argument.

  Parameters:
    `name` - Logical name of the `Log` instance to be returned (the meaning of this name is only known to the underlying logging implementation that is being wrapped)
  Throws:
    `LogConfigurationException` - if a suitable `Log` instance cannot be returned

### release

    public abstract void release()

  Release any internal references to previously created `Log` instances returned by this factory. This is useful in environments like servlet containers, which implement application reloading by throwing away a ClassLoader. Dangling references to objects in that class loader would prevent garbage collection.

### removeAttribute

    public abstract void removeAttribute(java.lang.String name)

  Remove any configuration attribute associated with the specified name. If there is no such attribute, no action is taken.

  Parameters:
    `name` - Name of the attribute to remove

### setAttribute

    public abstract void setAttribute(java.lang.String name,
                                      java.lang.Object value)

  Set the configuration attribute with the specified name. Calling this with a `null` value is equivalent to calling `removeAttribute(name)`.

  Parameters:
    `name` - Name of the attribute to set
    `value` - Value of the attribute to set, or `null` to remove any setting for this attribute

### getFactory

    public static LogFactory getFactory()
                                 throws LogConfigurationException

  Construct (if necessary) and return a `LogFactory` instance, using the following ordered lookup procedure to determine the name of the implementation class to be loaded.

  - The `org.apache.commons.logging.LogFactory` system property.
  - The JDK 1.3 Service Discovery mechanism
  - Use the properties file `commons-logging.properties` file, if found in the class path of this class. The configuration file is in standard `java.util.Properties` format and contains the fully qualified name of the implementation class with the key being the system property defined above.
  - Fall back to a default implementation class (`org.apache.commons.logging.impl.LogFactoryImpl`).

  NOTE - If the properties file method of identifying the `LogFactory` implementation class is utilized, all of the properties defined in this file will be set as configuration attributes on the corresponding `LogFactory` instance.

  NOTE - In a multithreaded environment it is possible that two different instances will be returned for the same classloader environment.

  Throws:
    `LogConfigurationException` - if the implementation class is not available or cannot be instantiated.

### getLog

    public static Log getLog(java.lang.Class clazz)
                      throws LogConfigurationException

  Convenience method to return a named logger, without the application having to care about factories.

  Parameters:
    `clazz` - Class from which a log name will be derived
  Throws:
    `LogConfigurationException` - if a suitable `Log` instance cannot be returned

### getLog

    public static Log getLog(java.lang.String name)
                      throws LogConfigurationException

  Convenience method to return a named logger, without the application having to care about factories.

  Parameters:
    `name` - Logical name of the `Log` instance to be returned (the meaning of this name is only known to the underlying logging implementation that is being wrapped)
  Throws:
    `LogConfigurationException` - if a suitable `Log` instance cannot be returned

### release

    public static void release(java.lang.ClassLoader classLoader)

  Release any internal references to previously created `LogFactory` instances that have been associated with the specified class loader (if any), after calling the instance method `release()` on each of them.

  Parameters:
    `classLoader` - ClassLoader for which to release the LogFactory

### releaseAll

    public static void releaseAll()

  Release any internal references to previously created `LogFactory` instances, after calling the instance method `release()` on each of them. This is useful in environments like servlet containers, which implement application reloading by throwing away a ClassLoader. Dangling references to objects in that class loader would prevent garbage collection.

### getClassLoader

    protected static java.lang.ClassLoader getClassLoader(java.lang.Class clazz)

  Safely get access to the classloader for the specified class.

  Theoretically, calling getClassLoader can throw a security exception, and so should be done under an AccessController in order to provide maximum flexibility. However in practice people don't appear to use security policies that forbid getClassLoader calls. So for the moment all code is written to call this method rather than Class.getClassLoader, so that we could put AccessController stuff in this method without any disruption later if we need to.

  Even when using an AccessController, however, this method can still throw SecurityException. Commons-logging basically relies on the ability to access classloaders, ie a policy that forbids all classloader access will also prevent commons-logging from working: currently this method will throw an exception preventing the entire app from starting up. Maybe it would be good to detect this situation and just disable all commons-logging? Not high priority though - as stated above, security policies that prevent classloader access aren't common.

  Note that returning an object fetched via an AccessController would technically be a security flaw anyway; untrusted code that has access to a trusted JCL library could use it to fetch the classloader for a class even when forbidden to do so directly.

  Since:
    1.1

### getContextClassLoader

    protected static java.lang.ClassLoader getContextClassLoader()
                                                          throws LogConfigurationException

  Returns the current context classloader.

  In versions prior to 1.1, this method did not use an AccessController. In version 1.1, an AccessController wrapper was incorrectly added to this method, causing a minor security flaw.

  In version 1.1.1 this change was reverted; this method no longer uses an AccessController. User code wishing to obtain the context classloader must invoke this method via AccessController.doPrivileged if it needs support for that.

  Returns:
    the context classloader associated with the current thread, or null if security doesn't allow it.
  Throws:
    `LogConfigurationException` - if there was some weird error while attempting to get the context classloader.
    `java.lang.SecurityException` - if the current java security policy doesn't allow this class to access the context classloader.

### directGetContextClassLoader

    protected static java.lang.ClassLoader directGetContextClassLoader()
                                                                throws LogConfigurationException

  Return the thread context class loader if available; otherwise return null.

  Most/all code should call getContextClassLoaderInternal rather than calling this method directly.

  The thread context class loader is available for JDK 1.2 or later, if certain security conditions are met.

  Note that no internal logging is done within this method because this method is called every time LogFactory.getLogger() is called, and we don't want too much output generated here.

  Throws:
    `LogConfigurationException` - if a suitable class loader cannot be identified.
    `java.lang.SecurityException` - if the java security policy forbids access to the context classloader from one of the classes in the current call stack.
  Since:
    1.1

### newFactory

    protected static LogFactory newFactory(java.lang.String factoryClass,
                                           java.lang.ClassLoader classLoader,
                                           java.lang.ClassLoader contextClassLoader)
                                    throws LogConfigurationException

  Return a new instance of the specified `LogFactory` implementation class, loaded by the specified class loader. If that fails, try the class loader used to load this (abstract) LogFactory.

  ## ClassLoader conflicts

  Note that there can be problems if the specified ClassLoader is not the same as the classloader that loaded this class, ie when loading a concrete LogFactory subclass via a context classloader.

  The problem is the same one that can occur when loading a concrete Log subclass via a context classloader.

  The problem occurs when code running in the context classloader calls class X which was loaded via a parent classloader, and class X then calls LogFactory.getFactory (either directly or via LogFactory.getLog). Because class X was loaded via the parent, it binds to LogFactory loaded via the parent. When the code in this method finds some LogFactoryYYYY class in the child (context) classloader, and there also happens to be a LogFactory class defined in the child classloader, then LogFactoryYYYY will be bound to LogFactory@childloader. It cannot be cast to LogFactory@parentloader, ie this method cannot return the object as the desired type. Note that it doesn't matter if the LogFactory class in the child classloader is identical to the LogFactory class in the parent classloader, they are not compatible.

  The solution taken here is to simply print out an error message when this occurs then throw an exception. The deployer of the application must ensure they remove all occurrences of the LogFactory class from the child classloader in order to resolve the issue. Note that they do not have to move the custom LogFactory subclass; that is ok as long as the only LogFactory class it can find to bind to is in the parent classloader.

  Parameters:
    `factoryClass` - Fully qualified name of the `LogFactory` implementation class
    `classLoader` - ClassLoader from which to load this class
    `contextClassLoader` - is the context that this new factory will manage logging for.
  Throws:
    `LogConfigurationException` - if a suitable instance cannot be created
  Since:
    1.1

### newFactory

    protected static LogFactory newFactory(java.lang.String factoryClass,
                                           java.lang.ClassLoader classLoader)

  Method provided for backwards compatibility; see newFactory version that takes 3 parameters.

  This method would only ever be called in some rather odd situation. Note that this method is static, so overriding in a subclass doesn't have any effect unless this method is called from a method in that subclass. However this method only makes sense to use from the getFactory method, and as that is almost always invoked via LogFactory.getFactory, any custom definition in a subclass would be pointless. Only a class with a custom getFactory method, then invoked directly via CustomFactoryImpl.getFactory or similar would ever call this. Anyway, it's here just in case, though the "managed class loader" value output to the diagnostics will not report the correct value.

### createFactory

    protected static java.lang.Object createFactory(java.lang.String factoryClass,
                                                    java.lang.ClassLoader classLoader)

  Implements the operations described in the javadoc for newFactory.

  Parameters:
    `factoryClass` -
    `classLoader` - used to load the specified factory class. This is expected to be either the TCCL or the classloader which loaded this class. Note that the classloader which loaded this class might be "null" (ie the bootloader) for embedded systems.
  Returns:
    either a LogFactory object or a LogConfigurationException object.
  Since:
    1.1

### isDiagnosticsEnabled

    protected static boolean isDiagnosticsEnabled()

  Indicates true if the user has enabled internal logging.

  By the way, sorry for the incorrect grammar, but calling this method areDiagnosticsEnabled just isn't java beans style.

  Returns:
    true if calls to logDiagnostic will have any effect.
  Since:
    1.1

### logRawDiagnostic

    protected static final void logRawDiagnostic(java.lang.String msg)

  Write the specified message to the internal logging destination.

  Parameters:
    `msg` - is the diagnostic message to be output.
  Since:
    1.1

### objectId

    public static java.lang.String objectId(java.lang.Object o)

  Returns a string that uniquely identifies the specified object, including its class.

  The returned string is of form "classname@hashcode", ie is the same as the return value of the Object.toString() method, but works even when the specified object's class has overidden the toString method.

  Parameters:
    `o` - may be null.
  Returns:
    a string of form classname@hashcode, or "null" if param o is null.
  Since:
    1.1

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2001-2007 The Apache Software Foundation. All Rights Reserved.